## dolfin 2019.2.0~legacy20240219.1c52e83

=== CMakeLists.txt ===
# Top level CMakeLists.txt file for DOLFIN

# Require CMake 3.5
cmake_minimum_required(VERSION 3.5)

#------------------------------------------------------------------------------
# Set project name and version number

project(DOLFIN)
set(DOLFIN_VERSION_RELEASE 0)
set(DOLFIN_VERSION_MAJOR "2019")
set(DOLFIN_VERSION_MINOR "2")
set(DOLFIN_VERSION_MICRO "0")
set(DOLFIN_VERSION "${DOLFIN_VERSION_MAJOR}.${DOLFIN_VERSION_MINOR}.${DOLFIN_VERSION_MICRO}")
if (NOT DOLFIN_VERSION_RELEASE)
  set(DOLFIN_VERSION "${DOLFIN_VERSION}.dev0")
endif()

#------------------------------------------------------------------------------
# Require and use C++11

# Use C++11
set(CMAKE_CXX_STANDARD 11)

# Require C++11
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Do not enable compler-specific extensions
set(CMAKE_CXX_EXTENSIONS OFF)

#------------------------------------------------------------------------------
# Check compiler version

# Check for GCC version - earlier versions have insuffcient C++11
# support, or bugs.
if (CMAKE_COMPILER_IS_GNUCXX)
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8.3)
    message(FATAL_ERROR "GCC version must be at least 4.8.3 (for sufficient C++11  support and to avoid some compiler bugs). You have version ${CMAKE_CXX_COMPILER_VERSION}")
  endif()
endif()

#------------------------------------------------------------------------------
# Get GIT changeset, if available

# Check for git
find_program(GIT_FOUND git)

if (GIT_FOUND)
  # Get the commit hash of the working branch
  execute_process(COMMAND git rev-parse HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )
else()
  set(GIT_COMMIT_HASH "unknown")
endif()

#------------------------------------------------------------------------------
# General configuration

# Set CMake options, see `cmake --help-policy CMP000x`
if (COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0004 NEW)
  cmake_policy(SET CMP0042 NEW)
endif()

# Set location of our FindFoo.cmake modules
set(DOLFIN_CMAKE_DIR "${DOLFIN_SOURCE_DIR}/cmake" CACHE INTERNAL "")
set(CMAKE_MODULE_PATH "${DOLFIN_CMAKE_DIR}/modules")

# Make sure CMake uses the correct DOLFINConfig.cmake for tests and demos
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/dolfin)

#------------------------------------------------------------------------------
# Configurable options for how we want to build

include(FeatureSummary)

option(BUILD_SHARED_LIBS "Build DOLFIN with shared libraries." ON)
option(CMAKE_USE_RELATIVE_PATHS "Use relative paths in makefiles and projects." OFF)
option(DOLFIN_AUTO_DETECT_MPI "Detect MPI automatically (turn this off to use the MPI compiler wrappers directly via setting CXX, CXX, FC)." ON)
option(DOLFIN_DEPRECATION_ERROR "Turn deprecation warnings into errors." OFF)
option(DOLFIN_ENABLE_BENCHMARKS "Enable benchmark programs." OFF)
option(DOLFIN_ENABLE_CODE_COVERAGE "Enable code coverage." OFF)
option(DOLFIN_ENABLE_DOCS "Enable generation of documentation." ON)
option(DOLFIN_SKIP_BUILD_TESTS "Skip build tests for testing usability of dependency packages." OFF)
option(DOLFIN_WITH_LIBRARY_VERSION "Build with library version information." ON)
option(DOLFIN_ENABLE_GEOMETRY_DEBUGGING "Enable geometry debugging (developers only; requires libcgal-dev and libcgal-qt5-dev)." OFF)

add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build DOLFIN with shared libraries.")
add_feature_info(CMAKE_USE_RELATIVE_PATHS CMAKE_USE_RELATIVE_PATHS "Use relative paths in makefiles and projects.")
add_feature_info(DOLFIN_AUTO_DETECT_MPI DOLFIN_AUTO_DETECT_MPI "Detect MPI automatically (turn this off to use the MPI compiler wrappers directly via setting CXX, CXX, FC).")
add_feature_info(DOLFIN_ENABLE_CODE_COVERAGE DOLFIN_ENABLE_CODE_COVERAGE "Enable code coverage.")
add_feature_info(DOLFIN_WITH_LIBRARY_VERSION DOLFIN_WITH_LIBRARY_VERSION "Build with library version information.")
add_feature_info(DOLFIN_ENABLE_BENCHMARKS DOLFIN_ENABLE_BENCHMARKS "Enable benchmark programs.")
add_feature_info(DOLFIN_ENABLE_DOCS DOLFIN_ENABLE_DOCS "Enable generation of documentation.")
add_feature_info(DOLFIN_SKIP_BUILD_TESTS DOLFIN_SKIP_BUILD_TESTS "Skip build tests for testing usability of dependency packages.")
add_feature_info(DOLFIN_DEPRECATION_ERROR DOLFIN_DEPRECATION_ERROR "Turn deprecation warnings into errors.")
add_feature_info(DOLFIN_ENABLE_GEOMETRY_DEBUGGING DOLFIN_ENABLE_GEOMETRY_DEBUGGING "Enable geometry debugging.")

# Add shared library paths so shared libs in non-system paths are found
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath." ON)
add_feature_info(CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath.")

# Hande RPATH on OSX when not installing to a system directory, see
# https://groups.google.com/d/msg/fenics-dev/KSCrob4M_1M/zsJwdN-SCAAJ
# and https://cmake.org/Wiki/CMake_RPATH_handling#Always_full_RPATH.
if (APPLE)
  # The RPATH to be used when installing, but only if it's not a
  # system directory
  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
  IF("${isSystemDir}" STREQUAL "-1")
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  ENDIF("${isSystemDir}" STREQUAL "-1")
endif()

#------------------------------------------------------------------------------
# Enable or disable optional packages

# List optional packages
set(OPTIONAL_PACKAGES "")
list(APPEND OPTIONAL_PACKAGES "MPI")
list(APPEND OPTIONAL_PACKAGES "PETSc")
list(APPEND OPTIONAL_PACKAGES "SLEPc")
list(APPEND OPTIONAL_PACKAGES "Trilinos")
list(APPEND OPTIONAL_PACKAGES "UMFPACK")
list(APPEND OPTIONAL_PACKAGES "CHOLMOD")
list(APPEND OPTIONAL_PACKAGES "SCOTCH")
list(APPEND OPTIONAL_PACKAGES "ParMETIS")
list(APPEND OPTIONAL_PACKAGES "SUNDIALS")
list(APPEND OPTIONAL_PACKAGES "zlib")
list(APPEND OPTIONAL_PACKAGES "HDF5")

# Add options
foreach (OPTIONAL_PACKAGE ${OPTIONAL_PACKAGES})
  string(TOUPPER "DOLFIN_ENABLE_${OPTIONAL_PACKAGE}" OPTION_NAME)
  option(${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}." ON)
  add_feature_info(${OPTION_NAME} ${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}.")
endforeach()

#------------------------------------------------------------------------------
# Package-specific options

# None at the moment

#------------------------------------------------------------------------------
# Compiler flags

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug Developer MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Check for some compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-pipe HAVE_PIPE)
if (HAVE_PIPE)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-pipe ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Add some strict compiler checks
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-Wall -Werror -pedantic ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Debug flags
CHECK_CXX_COMPILER_FLAG(-g HAVE_DEBUG)
if (HAVE_DEBUG)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-g ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

CHECK_CXX_COMPILER_FLAG(-O2 HAVE_O2_OPTIMISATION)
if (HAVE_O2_OPTIMISATION)
  set(DOLFIN_CXX_DEVELOPER_FLAGS "-O2 ${DOLFIN_CXX_DEVELOPER_FLAGS}")
endif()

# Set 'Developer' build type flags
set(CMAKE_CXX_FLAGS_DEVELOPER "${DOLFIN_CXX_DEVELOPER_FLAGS}" CACHE STRING
  "Flags used by the compiler during development." FORCE)

# Add flags for generating code coverage reports
if (DOLFIN_ENABLE_CODE_COVERAGE AND CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
endif()

# Settings for Intel compilers
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  # Use -isystem incluse flag with Intel compiler
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")

  # Stop spurious warnings from older Intel compilers
  if("${CMAKE_CXX_COMPILER_VERSION}" LESS "13")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -wd654,1125")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -wd654,1125")
    set(CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER} -wd654,1125")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -wd654,1125")
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -wd654,1125")
  endif()
endif()

# Set system include flags to get around CMake bug on OSX with gcc See
# http://public.kitware.com/Bug/print_bug_page.php?bug_id=10837
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
endif()

if (APPLE)
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
  set(CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER} -Wno-long-long")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wno-long-long")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -Wno-long-long")
endif()

#------------------------------------------------------------------------------
# Check for MPI

# FIXME: Should be set CMake to use the MPI compiler wrappers?

if (DOLFIN_ENABLE_MPI)
  if (DOLFIN_AUTO_DETECT_MPI)
    find_package(MPI)
    set_package_properties(MPI PROPERTIES TYPE OPTIONAL
      DESCRIPTION "Message Passing Interface (MPI)"
      PURPOSE "Enables DOLFIN to run in parallel with MPI")
  else()
    # Assume user has set MPI compiler wrappers (via CXX, etc or
    # CMAKE_CXX_COMPILER, etc)
    set(MPI_CXX_FOUND TRUE)
    set(MPI_C_FOUND TRUE)
  endif()
endif()

#------------------------------------------------------------------------------
# Run tests to find required packages

# Check for Boost
set(BOOST_ROOT $ENV{BOOST_DIR} $ENV{BOOST_HOME})
if (BOOST_ROOT)
  set(Boost_NO_SYSTEM_PATHS on)
endif()

# Prevent FindBoost.cmake from looking for system Boost{foo}.cmake
# files
set(Boost_NO_BOOST_CMAKE true)

set(Boost_USE_MULTITHREADED $ENV{BOOST_USE_MULTITHREADED})
find_package(Boost 1.56 QUIET REQUIRED)

# Boost public/private libraries to link to.
# Note: These should all be private as they do not appear in the
# DOLFIN public interface , but there is a linking issues with older
# Boost or CMake. Ubuntu 16.04 requires linking DOLFIN programs with
# filesystem, whereas Ubuntu 16.10 and macOS (Homebrew) do not.
if (Boost_VERSION VERSION_LESS 106100)
  set(DOLFIN_BOOST_COMPONENTS_PUBLIC filesystem timer)
  set(DOLFIN_BOOST_COMPONENTS_PRIVATE program_options iostreams)
else()
  set(DOLFIN_BOOST_COMPONENTS_PUBLIC timer)
  set(DOLFIN_BOOST_COMPONENTS_PRIVATE filesystem program_options iostreams)
endif()

# Find required Boost libraries
find_package(Boost COMPONENTS
  ${DOLFIN_BOOST_COMPONENTS_PUBLIC} ${DOLFIN_BOOST_COMPONENTS_PRIVATE} REQUIRED)
set_package_properties(Boost PROPERTIES TYPE REQUIRED
  DESCRIPTION "Boost C++ libraries"
  URL "http://www.boost.org")

# Check for required package Eigen3
find_package(Eigen3 3.2.90 REQUIRED)
set_package_properties(Eigen3 PROPERTIES TYPE REQUIRED
  DESCRIPTION "Lightweight C++ template library for linear algebra"
  URL "http://eigen.tuxfamily.org")

#------------------------------------------------------------------------------
# Run tests to find optional packages

# Is this still needed?
find_package(PythonInterp 3)

set_package_properties(PythonInterp PROPERTIES TYPE REQUIRED
  DESCRIPTION "Interactive high-level object-oriented language"
  URL "http://www.python.org")

# Check for required package UFC
find_package(UFC MODULE ${DOLFIN_VERSION_MAJOR}.${DOLFIN_VERSION_MINOR})
set_package_properties(UFC PROPERTIES TYPE REQUIRED
  DESCRIPTION "Unified language for form-compilers (part of FFC)"
  URL "https://bitbucket.org/fenics-project/ffc")

# Check for PETSc and SLEPc
set(PETSC_FOUND FALSE)

=== doc/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = FEniCSProject
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== fem/CMakeLists.txt ===
set(HEADERS
  assemble.h
  assemble_local.h
  AssemblerBase.h
  Assembler.h
  BasisFunction.h
  DirichletBC.h
  DiscreteOperators.h
  DofMapBuilder.h
  DofMap.h
  dolfin_fem.h
  Equation.h
  fem_utils.h
  FiniteElement.h
  Form.h
  GenericDofMap.h
  LinearTimeDependentProblem.h
  LinearVariationalProblem.h
  LinearVariationalSolver.h
  LocalAssembler.h
  LocalSolver.h
  MixedAssembler.h
  MixedLinearVariationalProblem.h
  MixedLinearVariationalSolver.h
  MultiMeshAssembler.h
  MultiMeshDirichletBC.h
  MultiMeshDofMap.h
  MultiMeshForm.h
  NonlinearVariationalProblem.h
  NonlinearVariationalSolver.h
  MixedNonlinearVariationalProblem.h
  MixedNonlinearVariationalSolver.h
  PETScDMCollection.h
  PointSource.h
  solve.h
  SparsityPatternBuilder.h
  SystemAssembler.h
  UFC.h
  PARENT_SCOPE)

set(SOURCES
  assemble.cpp
  assemble_local.cpp
  AssemblerBase.cpp
  Assembler.cpp
  DirichletBC.cpp
  DiscreteOperators.cpp
  DofMapBuilder.cpp
  DofMap.cpp
  Equation.cpp
  fem_utils.cpp
  FiniteElement.cpp
  Form.cpp
  LinearTimeDependentProblem.cpp
  LinearVariationalProblem.cpp
  LinearVariationalSolver.cpp
  LocalAssembler.cpp
  LocalSolver.cpp
  MixedAssembler.cpp
  MixedLinearVariationalProblem.cpp
  MixedLinearVariationalSolver.cpp
  MultiMeshAssembler.cpp
  MultiMeshDirichletBC.cpp
  MultiMeshDofMap.cpp
  MultiMeshForm.cpp
  NonlinearVariationalProblem.cpp
  NonlinearVariationalSolver.cpp
  MixedNonlinearVariationalProblem.cpp
  MixedNonlinearVariationalSolver.cpp
  PointSource.cpp
  PETScDMCollection.cpp
  solve.cpp
  SparsityPatternBuilder.cpp
  SystemAssembler.cpp
  UFC.cpp
  PARENT_SCOPE)

=== generation/CMakeLists.txt ===
set(HEADERS
  BoxMesh.h
  dolfin_generation.h
  IntervalMesh.h
  RectangleMesh.h
  SphericalShellMesh.h
  UnitCubeMesh.h
  UnitDiscMesh.h
  UnitIntervalMesh.h
  UnitSquareMesh.h
  UnitTetrahedronMesh.h
  UnitTriangleMesh.h
  PARENT_SCOPE)

set(SOURCES
  BoxMesh.cpp
  IntervalMesh.cpp
  RectangleMesh.cpp
  SphericalShellMesh.cpp
  UnitDiscMesh.cpp
  UnitTetrahedronMesh.cpp
  UnitTriangleMesh.cpp
  PARENT_SCOPE)

=== la/CMakeLists.txt ===
set(HEADERS
  Amesos2LUSolver.h
  BelosKrylovSolver.h
  BlockMatrix.h
  BlockVector.h
  CoordinateMatrix.h
  DefaultFactory.h
  dolfin_la.h
  EigenFactory.h
  EigenKrylovSolver.h
  EigenLUSolver.h
  EigenMatrix.h
  EigenVector.h
  GenericLinearAlgebraFactory.h
  GenericLinearOperator.h
  GenericLinearSolver.h
  GenericMatrix.h
  GenericTensor.h
  GenericVector.h
  Ifpack2Preconditioner.h
  IndexMap.h
  KrylovSolver.h
  LinearAlgebraObject.h
  LinearOperator.h
  LinearSolver.h
  LUSolver.h
  Matrix.h
  MueluPreconditioner.h
  PETScBaseMatrix.h
  PETScFactory.h
  PETScKrylovSolver.h
  PETScLinearOperator.h
  PETScLUSolver.h
  PETScMatrix.h
  PETScNestMatrix.h
  PETScObject.h
  PETScOptions.h
  PETScPreconditioner.h
  PETScVector.h
  Scalar.h
  SLEPcEigenSolver.h
  solve.h
  SparsityPattern.h
  SUNDIALSNVector.h
  TensorLayout.h
  test_nullspace.h
  TpetraFactory.h
  TpetraMatrix.h
  TpetraVector.h
  TrilinosParameters.h
  TrilinosPreconditioner.h
  Vector.h
  VectorSpaceBasis.h
  PARENT_SCOPE)

set(SOURCES
  Amesos2LUSolver.cpp
  BelosKrylovSolver.cpp
  BlockMatrix.cpp
  BlockVector.cpp
  CoordinateMatrix.cpp
  DefaultFactory.cpp
  EigenFactory.cpp
  EigenKrylovSolver.cpp
  EigenLUSolver.cpp
  EigenMatrix.cpp
  EigenVector.cpp
  GenericLinearSolver.cpp
  GenericMatrix.cpp
  Ifpack2Preconditioner.cpp
  IndexMap.cpp
  KrylovSolver.cpp
  LinearOperator.cpp
  LinearSolver.cpp
  LUSolver.cpp
  MueluPreconditioner.cpp
  PETScBaseMatrix.cpp
  PETScFactory.cpp
  PETScKrylovSolver.cpp
  PETScLinearOperator.cpp
  PETScLUSolver.cpp
  PETScMatrix.cpp
  PETScNestMatrix.cpp
  PETScObject.cpp
  PETScOptions.cpp
  PETScPreconditioner.cpp
  PETScVector.cpp
  SLEPcEigenSolver.cpp
  solve.cpp
  SparsityPattern.cpp
  TensorLayout.cpp
  test_nullspace.cpp
  TpetraFactory.cpp
  TpetraMatrix.cpp
  TpetraVector.cpp
  TrilinosParameters.cpp
  VectorSpaceBasis.cpp
  PARENT_SCOPE)

=== log/CMakeLists.txt ===
set(HEADERS
  dolfin_log.h
  Event.h
  Logger.h
  log.h
  LogLevel.h
  LogManager.h
  LogStream.h
  Progress.h
  Table.h
  PARENT_SCOPE)

set(SOURCES
  Event.cpp
  log.cpp
  Logger.cpp
  LogManager.cpp
  LogStream.cpp
  Progress.cpp
  Table.cpp
  PARENT_SCOPE)

=== multistage/CMakeLists.txt ===
set(HEADERS
  dolfin_multistage.h
  MultiStageScheme.h
  PointIntegralSolver.h
  RKSolver.h
  PARENT_SCOPE)

set(SOURCES
  MultiStageScheme.cpp
  PointIntegralSolver.cpp
  RKSolver.cpp
  PARENT_SCOPE)

=== parameter/CMakeLists.txt ===
set(HEADERS
  dolfin_parameter.h
  GlobalParameters.h
  Parameter.h
  Parameters.h
  PARENT_SCOPE)

set(SOURCES
  GlobalParameters.cpp
  Parameter.cpp
  Parameters.cpp
  PARENT_SCOPE)

=== refinement/CMakeLists.txt ===
set(HEADERS
  BisectionRefinement1D.h
  dolfin_refinement.h
  LocalMeshCoarsening.h
  ParallelRefinement.h
  PlazaRefinementND.h
  refine.h
  RegularCutRefinement.h
  PARENT_SCOPE)

set(SOURCES
  BisectionRefinement1D.cpp
  LocalMeshCoarsening.cpp
  ParallelRefinement.cpp
  PlazaRefinementND.cpp
  refine.cpp
  RegularCutRefinement.cpp
  PARENT_SCOPE)

=== debian/changelog ===
dolfin (2019.2.0~legacy20240219.1c52e83-24) unstable; urgency=medium

  * Also skip ghost-mesh demo in parallel, which has the same matplotlib crash
    as in the previous upload.

 -- Francesco Ballarin <ballarin@debian.org>  Tue, 14 Oct 2025 10:21:06 +0000

dolfin (2019.2.0~legacy20240219.1c52e83-23) unstable; urgency=medium

  * Skip mesh-quality demo on debci since matplotlib crashes on several arches
    (currently: arm64, ppc64el, s390x) with error message
    malloc(): unaligned tcache chunk detected

 -- Francesco Ballarin <ballarin@debian.org>  Mon, 13 Oct 2025 09:00:19 +0000

dolfin (2019.2.0~legacy20240219.1c52e83-22) unstable; urgency=medium

  * Acknowledge that uploads after 2019.2.0~legacy20240219.1c52e83-19, break
    python3-mshr uploads earlier than 2019.2.0~git20230811.ff54a68+dfsg1-5,
    because dolfin and mshr python wrappers need to be built with matching
    pybind11 versions.
  * Decrease verbosity in pusimp tests. Closes: #1116703.

 -- Francesco Ballarin <ballarin@debian.org>  Sat, 04 Oct 2025 13:32:33 +0000

dolfin (2019.2.0~legacy20240219.1c52e83-21) unstable; urgency=medium

  * Require python3-dijitso >= 2019.2.0~git20190418.c92dcb0-5~, which has a
    matching patch use-c++-14.patch
  * Fix previous incorrect upload:
    - The previous source upload was missing boost dependencies due to a local
      change was NOT supposed to be uploaded. Apologies.

 -- Francesco Ballarin <ballarin@debian.org>  Thu, 11 Sep 2025 10:34:26 +0000

dolfin (2019.2.0~legacy20240219.1c52e83-20) unstable; urgency=medium

  * Add patch use-c++-14.patch.
    - Boost.Math (used in the evaluation of Legendre functions) now requires
      C++14.
    - Closes: #1110575 (again).

 -- Francesco Ballarin <ballarin@debian.org>  Thu, 11 Sep 2025 08:27:29 +0000

dolfin (2019.2.0~legacy20240219.1c52e83-19) unstable; urgency=medium

  * Drop extraneous runtime dependency on python3-six [Alexandre Detiste]
  * Update email address of Francesco Ballarin
  * Standards-Version: 4.7.2 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * No tab in license text (routine-update)
  * Use secure URI in Homepage field.
  * Add missing build dependency on python3-numpy-dev for command dh_numpy3.
  * Use DEB_VERSION provided by /usr/share/dpkg/default.mk instead of querying
    dpkg-parsechangelog, as suggested by routine-update.
  * Add patch bump_minimum_boost_version.patch
    - This patch will be required when Boost 1.89 is packaged by debian
      because Boost 1.89 has removed the Boost.System library stub
    - FindBoost.CMake will still search for Boost.System library stub if the
      minimum required version of Boost declared in CMakeLists.txt is less than
      1.72.
    - Debian currently packages Boost 1.83, but there is no harm in including
      this patch now because Boost.System has been header only since 1.69, and
      therefore surely we do not need to include its library stub.
  * Add patch jit_avoid_distutils.patch
    - Patches a single line in python/dolfin/jit/pybind11jit.py removing an
      import from distutils.
    - Rationale: distutils has been deprecated since python 3.10 and removed in
      python 3.12. While setuptools currently brings it back, there is no need
      to rely on that for an import that can be easily replaced to avoid
      distutils at all.
  * Add patch deprecated-boost-filesystem-extension.patch
    - Avoids calling deprecated boost::filesystem::extension in
      dolfin/io/File.cpp and dolfin/io/XMLFile.cpp
    - Closes: #1110575.
  * Add patch deprecated-std-bind2nd.patch
    - Avoids calling deprecated std::bind2nd in dolfin/io/H5File.cpp and
      dolfin/io/XMLFile.cpp

 -- Francesco Ballarin <ballarin@debian.org>  Tue, 09 Sep 2025 07:21:02 +0000

dolfin (2019.2.0~legacy20240219.1c52e83-18) unstable; urgency=medium

  * Skip test_collision_robustness_slow on every arch, including amd64

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 05 Feb 2025 06:24:50 +0000

dolfin (2019.2.0~legacy20240219.1c52e83-17) unstable; urgency=medium

  * Stop using numpy.float_ and numpy.longfloat, which were removed in numpy 2.
    These changes were added to test_float128.patch, since it already
    overlapped a few lines. Closes: #1095020.
  * Skip demo buckling-tao on autopkgtests, which has started to fail in
    parallel, see e.g.
    https://ci.debian.net/packages/d/dolfin/testing/amd64/57313372/
  * Skip test_collision_robustness_slow in file
    python/test/unit/geometry/test_geometry_issues.py which fails with
    OverflowError: Python integer -1 out of bounds for uint32

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Mon, 03 Feb 2025 08:14:56 +0000

dolfin (2019.2.0~legacy20240219.1c52e83-16) unstable; urgency=medium

  * debian/tests: run less tests to reduce timeout. Closes: #1088865
    - test default python only
    - skip slowest python demos

 -- Drew Parsons <dparsons@debian.org>  Wed, 15 Jan 2025 10:11:25 +0100

dolfin (2019.2.0~legacy20240219.1c52e83-15) unstable; urgency=medium

  * debian/tests: skip block-assembly-3D python demo (times out)

 -- Drew Parsons <dparsons@debian.org>  Tue, 14 Jan 2025 01:23:49 +0100

dolfin (2019.2.0~legacy20240219.1c52e83-14) unstable; urgency=medium

  * debian/tests: update MPI python unit test management
    to reduce risk of timeout
    - skip test_shared_entities[shared_vertex-mesh_factory8]), which
      has become flaky in python3.13, with the number of entities
      system dependent
    - run tests on default python only (especially for i386)
    - specify libopenblas-pthread-dev as preferred
      BLAS/LAPACK for tests. Use blis on armel.
    - run MPI python unit tests with OMP_NUM_THREADS=1

 -- Drew Parsons <dparsons@debian.org>  Sun, 12 Jan 2025 14:45:59 +0100

dolfin (2019.2.0~legacy20240219.1c52e83-13) unstable; urgency=medium



=== debian/control ===
Source: dolfin
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Johannes Ring <johannr@simula.no>,
           Drew Parsons <dparsons@debian.org>,
           Francesco Ballarin <ballarin@debian.org>
Section: math
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               gfortran,
               chrpath,
               libboost-chrono-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-math-dev,
               libboost-mpi-dev,
               libboost-program-options-dev,
               libboost-serialization-dev,
               libboost-thread-dev,
               libboost-timer-dev,
               libeigen3-dev,
               libhdf5-mpi-dev,
               libsuitesparse-dev,
               libscotch-dev,
               libxml2-dev,
               mpi-default-dev (>= 1.17),
               petsc-dev,
               slepc-dev,
               python3-petsc4py,
               python3-slepc4py,
               python3-petsc4py-real,
               python3-slepc4py-real,
               petsc64-dev,
               slepc64-dev,
               python3-petsc4py-64-real,
               python3-slepc4py-64-real,
               pybind11-dev,
               python3-setuptools,
               pkgconf,
               python3-pkgconfig,
               python3-all-dev,
               python3-ffc (>= 2019.2.0~git20210714.a20cbe7-4~),
               python3-ffc (<< 2019.3),
               python3-dijitso (>= 2019.2.0~git20190418.c92dcb0-5~),
               python3-dijitso (<< 2019.3),
               python3-ufl-legacy,
               python3-numpy-dev,
               python3-ply,
               python3-pusimp,
               python3-sphinx
Build-Depends-Indep: python3-sphinx-rtd-theme,
                     doxygen,
                     graphviz,
                     libjs-mathjax,
                     libjs-modernizr
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfin
Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfin.git
Homepage: https://fenicsproject.org

Package: libdolfin-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdolfin-dev-common,
         cmake,
         g++ | c++-compiler,
         libboost-chrono-dev,
         libboost-dev,
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-math-dev,
         libboost-mpi-dev,
         libboost-program-options-dev,
         libboost-serialization-dev,
         libboost-thread-dev,
         libboost-timer-dev,
         libdolfin2019.2t64 (= ${binary:Version}),
         libeigen3-dev,
         libhdf5-mpi-dev,
         libsuitesparse-dev,
         libscotch-dev,
         libxml2-dev,
         pkgconf,
         python3-ffc (>= ${fenics:Upstream-Version}),
         python3-ffc (<< ${fenics:Next-Upstream-Version}),
         ${petsc:Depends},
         ${misc:Depends}
Conflicts: libdolfin0-dev,
           libdolfin1.0-dev,
           libdolfin1.1-dev,
           libdolfin1.2-dev,
           libdolfin1.3-dev,
           libdolfin1.4-dev
Replaces: libdolfin0-dev,
          libdolfin1.0-dev,
          libdolfin1.1-dev,
          libdolfin1.2-dev,
          libdolfin1.3-dev,
          libdolfin1.4-dev
Description: Shared links and development files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files.
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation libdolfinx-dev (DOLFIN-X) instead.

Package: libdolfin-dev-common
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Conflicts: libdolfin0-dev,
           libdolfin1.0-dev,
           libdolfin1.1-dev,
           libdolfin1.2-dev,
           libdolfin1.3-dev,
           libdolfin1.4-dev
Replaces: libdolfin0-dev,
          libdolfin1.0-dev,
          libdolfin1.1-dev,
          libdolfin1.2-dev,
          libdolfin1.3-dev,
          libdolfin1.4-dev
Description: Common header files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the common development header files.
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation libdolfinx-dev (DOLFIN-X) instead.

Package: libdolfin2019.2t64
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: dolfin-doc,
          python3-dolfin
Breaks: libdolfin2019.2gcc13 (<< ${source:Version})
Provides: ${t64:Provides}
Replaces: libdolfin2019.2gcc13
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries.

Package: python3-dolfin
Architecture: any
Section: python
Depends: python3-dolfin-real | python3-dolfin64-real,
         python3-dijitso (>= ${fenics:Upstream-Version}),
         python3-dijitso (<< ${fenics:Next-Upstream-Version}),
         python3-ffc (>= 2019.2.0~git20210714.a20cbe7-4~),
         python3-ufl-legacy,
         python3-numpy,
         ${python3-petsc4py:Depends},
         python3-ply,
         python3-pusimp,
         python3-pybind11 (>= ${pybind11:Upstream-Version}),
         python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
         python3-sympy,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: dolfin-doc
Description: Base Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This is the base package depending on specific dolfin builds. By
 default the version built against the preferred version of PETSc in
 /usr/lib/petsc is selected (with 32-bit indexing, but the
 alternative version (64-bit PETSc) can be selected by setting the
 environment variable PETSC_DIR.
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation python3-dolfinx (DOLFIN-X) instead.

Package: python3-dolfin-real
Architecture: any
Section: python
Depends: libdolfin-dev (= ${binary:Version}),
         libdolfin2019.2t64 (= ${binary:Version}),
         ${python3-petsc4py-real:Depends},
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-dolfin (= ${binary:Version})
Breaks: python3-mshr-real (<< 2019.2.0~git20230811.ff54a68+dfsg1-5)
Description: Python interface for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3)
 build against the default version of PETSc (with 32-bit indexing)
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation python3-dolfinx (DOLFIN-X) instead.

Package: libdolfin64-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdolfin-dev,
         libdolfin-dev-common,
         cmake,
         g++ | c++-compiler,
         libboost-chrono-dev,
         libboost-dev,
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-math-dev,
         libboost-mpi-dev,
         libboost-program-options-dev,
         libboost-serialization-dev,
         libboost-thread-dev,
         libboost-timer-dev,
         libdolfin64-2019.2t64 (= ${binary:Version}),
         libeigen3-dev,
         libhdf5-mpi-dev,
         libsuitesparse-dev,
         libscotch-dev,
         libxml2-dev,
         pkgconf,
         python3-ffc (>= ${fenics:Upstream-Version}),
         python3-ffc (<< ${fenics:Next-Upstream-Version}),
         ${petsc64:Depends},
         ${misc:Depends}
Description: Shared links and dev files for DOLFIN (64-bit indexing)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files for DOLFIN built against
 64-bit PETSc (64-bit indexing).
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation libdolfinx-dev (DOLFIN-X) instead.

Package: libdolfin64-2019.2t64
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: dolfin-doc,
          python3-dolfin64-real
Breaks: libdolfin64-2019.2gcc13 (<< ${source:Version})
Provides: ${t64:Provides}
Replaces: libdolfin64-2019.2gcc13
Description: Shared libraries for DOLFIN (64-bit indexing)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries for DOLFIN built against
 64-bit PETSc (64-bit indexing).

Package: python3-dolfin64-real
Architecture: any
Section: python
Depends: libdolfin64-dev (= ${binary:Version}),
         libdolfin64-2019.2t64 (= ${binary:Version}),
         ${python3-petsc4py-64-real:Depends},
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-dolfin (= ${binary:Version})
Breaks: python3-mshr64-real (<< 2019.2.0~git20230811.ff54a68+dfsg1-5)
Description: Python interface for DOLFIN (with 64-bit PETSc integers)

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

OS_ID := $(shell grep -E "^ID" /etc/os-release | sed "s/^ID=//")

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
# Get DEBIAN_VERSION via /usr/share/dpkg/default.mk
include /usr/share/dpkg/default.mk
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

DEBIAN_VERSION_ID := $(OS_ID)_$(DEB_VERSION)

FENICS_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
FENICS_MAJOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
FENICS_MINOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
FENICS_VERSION=$(FENICS_MAJOR_VERSION).$(FENICS_MINOR_VERSION)
FENICS_NEXT_VERSION=$(FENICS_MAJOR_VERSION).$(shell echo $$(( $(FENICS_MINOR_VERSION) + 1 )) )

# dolfin depends on the pybind11 version it was built against,
# if pybind11.h will be used in C++ code fragments in python scripts.
# But pybind11 follows semantic versioning, so should have backwards compatibility
# with minor and patch version updates.
# Extract pybind11 version from pybind11-dev
PYBIND11_DEB_VERSION=$(shell dpkg -s pybind11-dev | awk '/Version:/ {print $$2}')
# extract the current pybind11 version X.Y.Z (drop epoch and debian package version)
PYBIND11_UPSTREAM_VERSION=$(shell echo $(PYBIND11_DEB_VERSION) | sed "s/^.[^:]*://; s/-[^-]*$$//")
PYBIND11_X_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\([^.]*\).*/\1/")
PYBIND11_X_Y_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
PYBIND11_VERSION=$(PYBIND11_X_Y_VERSION)
PYBIND11_NEXT_VERSION=$(shell echo $$(( $(PYBIND11_X_VERSION) + 1 )) )

# Allow test programs that use OpenMPI to run
export PRTE_MCA_plm_ssh_agent=/bin/false
export PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe
export OMPI_MCA_btl_base_warn_component_unused=0

include /usr/share/mpi-default-dev/debian_defaults
ENABLE_MPI=ON
ifeq ($(findstring $(DEB_BUILD_ARCH),$(OPENMPI_ARCHITECTURES)),)
MPIEXEC_PARAMS=
else
MPIEXEC_PARAMS=--oversubscribe
endif

DOLFIN_HOME = $(CURDIR)/$(DEB_SRCDIR)
USCAN_DESTDIR := $(CURDIR)
PY3VERS := $(shell py3versions --requested debian/control | tac -s' ')
PYVERS = $(PY3VERS)

BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)
BUILDDIR_64 = obj-$(DEB_HOST_GNU_TYPE)-64
TESTDIR = build-tests
TESTDIR_64 = build-tests-64

NPROC := $(shell nproc)
PARALLEL = $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
N_CPU    = $(or $(PARALLEL),$(NPROC),1)
# MPI tests are set up to run on 3 processes. Spread them leanly over the available processors (don't have more than 2 tests using one processor).
# e.g. run 1 MPI test at a time over 1-3 processors, or 2 tests at a time over 4-6 processors, or 3 tests over 7-9 processors, etc.
N_MPI := 3
N_MPI_TESTS = $(shell echo $$(( ($(N_CPU)+$(N_MPI)-1)/$(N_MPI) )) )

# some tests run slow (> 1000 sec) on all arches
ARCH_ALL_SKIP_SERIAL_TEST = demo_hyperelasticity_serial demo_cahn-hilliard_serial

# hyperelasticity fails (diverges) on all arches (pivot factors too large, not enough memory assigned)
# elastodynamics passes with dpkg-buildpackage but fails with pdebuild (on amd64). Unreliable, so skip.
ARCH_ALL_SKIP_MPI_TEST = demo_hyperelasticity_mpi demo_elastodynamics_mpi demo_mixed-poisson_mpi

# Some arches fail the same MPI tests
# e.g. cahn-hilliard, navier-stokes, elasticity, fails or exceeds allowed time
# So skip these tests on the failing arches
ARCH_SKIP_MPI_TEST_LIST = i386 mipsel ppc64el ia64
ARCH_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_navier-stokes_mpi demo_elasticity_mpi

# skip more MPI tests for some specific arches
ifeq (arm64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_navier-stokes_mpi
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
else ifeq (ppc64el, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_poisson_mpi demo_singular-poisson_mpi demo_sym-dirichlet-bc_mpi
else ifeq (ia64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_bcs_mpi demo_biharmonic_mpi demo_built-in-meshes_mpi demo_eigenvalue_mpi
else ifeq (sparc64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_contact-vi-snes_mpi
else
  ARCH_SPECIFIC_SKIP_MPI_TEST =
endif

# m68k,mips,hppa,sparc64 need some help to pass serial tests
ifeq (m68k, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_auto-adaptive-poisson_serial demo_elasticity_serial
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial
else ifeq (hppa, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_mixed-poisson_serial demo_stokes-taylor-hood_serial demo_auto-adaptive-navier-stokes_serial demo_contact-vi-snes_serial demo_multimesh-stokes_serial
else ifeq (sparc64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_contact-vi-snes_serial
else
  ARCH_SPECIFIC_SKIP_SERIAL_TEST =
endif


# skip slow tests (> 500-1000 sec to complete)
ifeq (armel, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_stokes-iterative_serial demo_auto-adaptive-navier-stokes_serial demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_hyperelasticity_serial demo_cahn-hilliard_serial
else ifeq (armhf, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_hyperelasticity_serial
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_eigenvalue_serial demo_navier-stokes_serial demo_auto-adaptive-poisson_serial demo_stokes-taylor-hood_serial demo_auto-adaptive-navier-stokes_serial demo_curl-curl_serial demo_elasticity_serial demo_stokes-iterative_serial demo_eval_serial demo_sym-dirichlet-bc_serial demo_elastodynamics_serial demo_eigenvalue_mpi demo_navier-stokes_mpi demo_curl-curl_mpi demo_elasticity_mpi demo_elastodynamics_mpi demo_sym-dirichlet-bc_mpi
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (alpha, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_hyperelasticity_serial
else ifeq (hppa, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (m68k, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (riscv64, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
else ifeq (sparc64, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_stokes-iterative_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
else
  ARCH_SKIP_SLOW_TEST =
endif

empty :=
space := $(empty)$(empty)

ARCH32_LIST = armel armhf i386 mipsel powerpc x32

ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 = $(ARCH_SPECIFIC_SKIP_SERIAL_TEST) demo_stokes-iterative_serial demo_curl-curl_serial
ARCH_SPECIFIC_SKIP_MPI_TEST_64 = $(ARCH_SPECIFIC_SKIP_MPI_TEST)

ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH32_LIST)$(space)))
  # these 4 tests fail in 64-bit build tests on 32-bit arches
  ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_mixed-poisson_serial demo_stokes-taylor-hood_serial demo_auto-adaptive-navier-stokes_serial demo_multimesh-stokes_serial
endif
ifeq (armel, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_contact-vi-snes_serial

=== debian/tests/control ===
Tests: test-dolfin-cpp,
# test-dolfin64-cpp,
Depends: @, @builddeps@,
	  libopenblas-pthread-dev [!armel] | libblis-pthread-dev
Restrictions: allow-stderr

Tests: test-dolfin-python-unittest,
 test-dolfin-python-demo
# test-dolfin64-cpp,
# test-dolfin64-python-unittest,
# test-dolfin64-python-demo
Depends: @, @builddeps@,
	  python3-dev,
	  python3-pytest,
	  python3-decorator,
	  python3-matplotlib,
	  python3-scipy,
	  libopenblas-pthread-dev [!armel] | libblis-pthread-dev

Tests: test-dolfin-python-pusimp
Architecture: !riscv64
Depends: @, @builddeps@,
 python3-all,
 python3-pip,
 python3-pytest,
 python3-requests,
 python3-virtualenv
Restrictions: needs-internet
